﻿# Variables 
$amtextfilepath = $env:am_logpath + "\WSUS_Offline_Logging\WsusOfflineBuildDate.txt"
$locupdatecmd = $env:locupdatecmd
$logfilelocation = $env:am_logpath + "\WSUS_Offline_Logging\WSUSOfflineLog.txt"
$mountdriveletter = "B"
$checkdriveletter = $mountdriveletter + ":"
$tmpsharepath = $env:locshareupdatecmd
$wsustextfilepath = $env:locshareupdatecmd + "\builddate.txt"
$cmdupdatevar = "/norestart /nobackup"


#log action variables
$8 = "The script is finished."
$a = "The am date file exists on the am share."
$b = "Date on AM share is older then the date on the WSUS share."
$c = "WSUS update proces started from share: " + "'" + $tmpsharepath + "'" + " Mounted under drive: " + $checkdriveletter
$d = "The date file on the AM Share is updated."
$e = "Date on WSUS share is older then the date on the AM share. No updates needed!"
$f = "The drive for starting a cmd is now mounted."
$g = "The drive is unmounted."
$h = "There is alreade a drive mounted with the same drive letter."
$i = "The script is started."
$j = "Script succesfully created logfile at: " + $logfilelocation
$k = "Date in the AM text file is processed. ===>"
$l = "Date in the WSUS Offline text file is processed. ===>"
$m = "AM date is converted to date object. ===>"
$n = "WSUS date is converted to date object. ===>"

# Always create log file or overwrite it.
New-Item $logfilelocation -Force

if(Test-Path $logfilelocation){

    # Get the time and put a first rule on top of the log file. Time and confirmation of creating the logfile.
    $currenttime = Get-Date -Format G
    Add-Content $logfilelocation "$currenttime | $j"

    # Get the time and put a first rule on top of the log file.
    $currenttime = Get-Date -Format G
    Add-Content $logfilelocation "$currenttime | $i"

    # Mount a drive, so a cmd could be started. if the given drive is not mounted, start the rest of the script.
    if(!(Test-Path $checkdriveletter)){
        Write-Output "Drive is not there"
        New-PSDrive -Name $mountdriveletter -PSProvider FileSystem -Root $tmpsharepath -Persist
    
        # logfile
        $currenttime = Get-Date -Format G
        Add-Content $logfilelocation "$currenttime | $f"

        # Statement to check if the file on the AM share exists, if so do some actions.
        if (Test-Path $amtextfilepath){
        
            # logfile
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $a"




            # Read the date from the files in am and wsus shares. Remove spaces and empty lines.
            $amdatevar = Get-Content -Path $amtextfilepath | Out-String
            $amdatevar = $amdatevar.Trim()

            # logfile
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $k $amdatevar"

            # Read the date from the files in am and wsus shares. Remove spaces and empty lines.
            $wsusdatevar = Get-Content -Path $wsustextfilepath | Out-String
            $wsusdatevar = $wsusdatevar.Trim()

            # logfile            
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $l $wsusdatevar"


            
            
            # Convert to date object amdate
            $amdateobject = [datetime]::ParseExact($amdatevar,"MM/dd/yyyy",$null)

            # logfile
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $m $amdateobject"

            # Convert to date object amdate
            $wsusdateobject = [datetime]::ParseExact($wsusdatevar,"MM/dd/yyyy",$null)

            # logfile
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $n $wsusdateobject"
            
            
            

            # Check if the am date object is older than the wsus date object. 
            # If equil there is no action needed.
            # If am date is older, do update.
            # if new build is available for wsus, with new date. Update.
            if($amdateobject -lt $wsusdateobject){
                
                # logfile
                $currenttime = Get-Date -Format G
                Add-Content $logfilelocation "$currenttime | $b"
            
                Start-Process $locupdatecmd $cmdupdatevar -Wait
            
                # logfile
                $currenttime = Get-Date -Format G
                Add-Content $logfilelocation "$currenttime | $c"
            
                Copy-Item $wsustextfilepath $amtextfilepath -Force
        
                # logfile
                $currenttime = Get-Date -Format G
                Add-Content $logfilelocation "$currenttime | $d"
        
            } else {

                # logfile
                $currenttime = Get-Date -Format G
                Add-Content $logfilelocation "$currenttime | $e"
            }

        } else {
        
            Start-Process $locupdatecmd $cmdupdatevar -Wait
        
            # logfile
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $c"
            $currenttime = Get-Date -Format G
            Add-Content $logfilelocation "$currenttime | $d"
    
            Copy-Item $wsustextfilepath $amtextfilepath -Force
        }

        # Unmount the mounted drive
        Remove-PSDrive -Name $mountdriveletter -Force

        # logfile
        $currenttime = Get-Date -Format G
        Add-Content $logfilelocation "$currenttime | $g"
        $currenttime = Get-Date -Format G
        Add-Content $logfilelocation "$currenttime | $8"

    } else {
    
        Write-Output "Drive is already there"
    
        # logfile
        $currenttime = Get-Date -Format G
        Add-Content $logfilelocation "$currenttime | $h"
    }

} else {

    # No log file found or created. EXIT
    Write-Output "No logfile found or created at: " + $logfilelocation
    Write-Output "=== EXITING SCRIPT ==="
}
